
#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

#Interface to store passwords and create
#sessionkeys for administrative logon
#Can be used for a more sophisticated
#permissions systems


import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
import string
import copy
import pdb
import profile
import whrandom
import time

#import MyUtil
#from MyUtil import *
import GenericCache
import MyUtil

""" 
Each User has a list of base serial number which he can access. 

"""


currentPermissions = None
global currentPermissions 


#Key words: IsAdmin, SessionKey


##Two different approaches
##Reconstituted

class User:
	def __init__(self, 
		name, 
		password,
		accessPoint):
		self.accessList = []
		if type(accessPoint) == type(""):
			self.accessList.append(accessPoint)
		elif type(accessPoint) == type([]):
			self.accessList = self.accessList + accessPoint
		self.name = name
		self.password = password

#	htmlFileToSerialNum = GenericCache.GenericCache(
#		'htmlFileToSerialNum',MyUtil.MainObjectCache)

class UserList:
	SessionKeys = None
	UserInfoDictionary = None
	currentUser = None
	
	def __init__(self):
		if UserList.SessionKeys is None:
			UserList.SessionKeys = GenericCache.GenericCache(
				'SessionKeys',MyUtil.AdminCache)

		if UserList.UserInfoDictionary is None:
			UserList.UserInfoDictionary = GenericCache.GenericCache(
				'UserInfoDictionary',MyUtil.AdminCache)

		if len(UserList.UserInfoDictionary.keys()) == 0:
			self.CreateUserAndPassword(
				'SnakeEyes','Humpty7','0')

		self.ExpireSessionKeys()
		
	def Cleanup(self):
		MyUtil.AdminCache.Flush()
	
	def ExpireSessionKeys(self):
		if len(UserList.SessionKeys) > 100:
			now = time.time()
			for i in UserList.SessionKeys.keys():
				keyTime = UserList.SessionKeys[i][0]
				if now - keyTime > 86400.0: #(24*60*60) one day of seconds
					del UserList.SessionKeys[i]

	def CreateSessionKey(self, userName, passString):
		#pdb.Pdb().set_trace()
		if UserList.UserInfoDictionary.has_key(userName):
			info = UserList.UserInfoDictionary[userName] 
			if info.password == passString:
				#Generate random number not already
				#a session key
				sessKeyStr = '%d' % whrandom.randint(
							1000,10000)
				while(UserList.SessionKeys.has_key(
					sessKeyStr)):
					sessKeyStr = '%d' % whrandom.randint(
								1000,100000)
				UserList.SessionKeys[sessKeyStr] = [time.time(),userName,passString]
				UserList.currentUser = userName
				self.currentSessionKey = sessKeyStr
				return sessKeyStr
			else:
				return ''
		else:
			return ''
			
	def CreateUserAndPassword(self, 
		userName, 
		passString,
		accessPoint):
		if UserList.UserInfoDictionary.has_key(userName):
			return 0
		else:
			UserList.UserInfoDictionary[userName] = \
				User(userName,passString,accessPoint)
			return 1
	
	def DestroyUser(self, userName):
		if UserList.UserInfoDictionary.has_key(userName):
			del UserList.UserInfoDictionary[userName]

	def VerifySessionKey(self, sessionKey):
		if(UserList.SessionKeys.has_key(sessionKey)):
			UserList.currentUser = (UserList.SessionKeys[sessionKey])
			self.currentSessionKey = sessionKey
			return 1
		else:
			return 0		
	
	def AllowModify(self, sessionKey, digest, serialNumToModify):
		if UserList.currentUser is not None:
			return 1
		else:
			return 0
		
#def main():
#		Admin.UserList(
#        ).CreateUserAndPassword('SnakeEyes','theAdmin','0')

#global TheUserList 
#TheUserList = UserList()

#if __name__ == '__main__':
#    main()

