
#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

# A serial number is a unique string of digits and ';:'
# used to identifying tokens

import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
import string
import copy
import pdb
import profile
from string import *

#import MyToken
import MyUtil

DELIM1 = '.'
DELIM2 = ';'

global SomeDecQuantity
global TheDecQuantityType

class DecQuantity:
	"""This class represents a persistant tree node object.
	It allows tree and ordering relations to be reconstructed from strings.
	0;0 == [[0],[0]] and is below 0 == [[0]]].
	Sibling nodes are ordered. So 0.5 is between 0 and 1
	0.5;0 is below 0.5;0 but not below 0;0.
	"""
	def __init__(self, quant = None, decimal = None):
		#will ALWAYS be a list o list o numbers
		self.listRep = [[]]
		if quant is None:
			pass
		elif type(quant) == TheDecQuantityType:
			quant = quant.listRep
		elif type(quant) == type(0):
			self.listRep[0].append(quant)
		elif type(quant) == type([]):
			if (len(quant) > 0 
				and type(quant[0]) == type(0)):
				self.listRep[0] = quant
			else:
				self.listRep = quant
		
		if decimal is None:
			pass
		elif type(decimal) == TheDecQuantityType:
			decimal = decimal.listRep
		elif type(decimal) == type(0):
			decimal = Quantity(decimal)
		elif type(decimal) == type([]):
			if (len(decimal) > 0 
				and type(quant[0]) == type(0)):
				if len(self.listRep[0]) > 0:
					self.listRep.append(decimal)
				else:
					self.listRep[0] = [decimal]
			else:
				self.listRep = self.listRep + decimal
	
	def __nonzero__(self):
		return(len(self.listRep) > 0 
			and len(self.listRep[0])>0)
	
	def addToRepresentation(listOrNum):
		if type(listOrNum) == type(0):
			self.listRep[0].append(quant)
			return
		if (len(listOrNum) > 0 ):
			if type(listOrNum[0]) == type(0):
				self.listRep[0].append(listOrNum)
				return
	
	def SetAsRepresentation(listOrNum):
		if type(listOrNum) == type(0):
			self.listRep[0]= [quant]
			return
		if (len(listOrNum) > 0 ):
			if type(listOrNum[0]) == type(0):
				if len(self.listRep) > 0:
					self.listRep[0] = listOrNum
				else:
					self.listRep = listOrNum	
				return
	
	def SetAsDecimal(quant):
		if type(quant) == type(0):
			self.listRep = self.listRep + \
				[[quant]]
			return
		
		elif len(quant) > 0:
			if type(quant[0]) == type(0):
				self.listRep = [self.listRep[0]] + \
					[quant]
			else:
				self.listRep = [self.listRep[0]] + \
					quant
			return
	
	def addToDecimal(listOrNum):
		if type(listOrNum) == type(0):
			self.listRep[-1].append([quant])
		if (len(listOrNum) > 0 ):
			if type(listOrNum[0]) == type(0):
				self.listRep[0].append(listOrNum)
				return
	

	#WAS The MOST COSTLY FUNCTION in the application
	def ACopyOf(self):
		aCopy = DecQuantity()
		aCopy.listRep = []
		for x in self.listRep:
			toApp = []
			for y in x:
				toApp.append(y)
			aCopy.listRep.append(toApp)
		return aCopy
	
	def __cmp__(self,toCompare):
		i = 0
		b = min(len(self.listRep), 
			len(toCompare.listRep))
		while i < b:
			j = 0
			innerB = min(len(self.listRep[i]),
				len(toCompare.listRep[i]) )
			while j < innerB :
				if (self.listRep[i][j] < 
					toCompare.listRep[i][j]):
					return -1
				if (self.listRep[i][j] > 
					toCompare.listRep[i][j]):
					return 1
				j = j+1
			if len(toCompare.listRep[i]) < len(self.listRep[i]):
				if self.listRep[i][len(toCompare.listRep[i])] < 0:
					return -1
				else:
					return 1
				
			if len(toCompare.listRep[i]) > len(self.listRep[i]):
				if toCompare.listRep[i][len(self.listRep[i])] < 0:
					return 1
				else:
					return -1
			i = i + 1
		#end While
		if len(toCompare.listRep) < len(self.listRep):
			if self.listRep[len(toCompare.listRep)][0] < 0:
				return -1
			else:
				return 1
		if len(toCompare.listRep) > len(self.listRep):
			if len(self.listRep) == 0:
				return 1
			if i+1 > len(self.listRep) :
				i = len(self.listRep) - 1
			end = len(self.listRep[i])
			while len(toCompare.listRep[end]) == 0:
				if end > 0:
					end = end -1
				else:
					return 1
			
			if toCompare.listRep[end][0] < 0:
				return 1
			else:
				return -1
		
		return 0
	
	def __str__(self):
		res = ''
		for x in self.listRep:
			for y in x:
				res = res + ('%d' % y) + DELIM1
			res = res[:-1] #pop off last inner delim
			res = res + DELIM2
		res = res[:-1] #and last outter
		
		return res
	
	#Allow equality
	#Test if isLower share same indexes as self
	def IsBelow(self,isLower):
		i = 0
		if len(isLower.listRep) < len(self.listRep):
			return 0

		l = len(self.listRep)
		while i < l :
			if( self.listRep[i]
				!= isLower.listRep[i]):
				return 0
			i = i + 1
		return 1

	def Decimal(self):
		return DecQuantity(self.listRep[1:])

	def Rep(self):
		return DecQuantity(self.listRep[0])
	
	
	def IsNull(self):
		if len(self.listRep) == 0:
			return 1
		if len(self.listRep[0]) == 0:
			return 1
		return 0
		
	def Next(self):
		nQ = DecQuantity()
		nQ = self.ACopyOf()
		if len(nQ .listRep) == 0:
			nQ.listRep[[0]] == 0
		else:
			nQ.listRep[-1] = [self.listRep[-1][0]+1]
		return nQ
	
	def NextMain(self):
		nQ = DecQuantity()
		nQ = self.ACopyOf()
		if len(nQ .listRep) == 0:
			nQ.listRep[[0]] == 0
		else:
			nQ.listRep[-1] = [self.listRep[-1][0]+1]
		
		return nQ
	
	def Prev(self):
		nQ = DecQuantity()
		nQ = self.ACopyOf()
		if len(nQ .listRep) == 0:
			nQ.listReprepList[[0]] == 0
		else:
			nQ.listRep[-1] = [self.listRep[-1][0]-1]
		
		return nQ

	def Between(self,upper):
		if (self == upper):
			return self.ACopyOf()
		elif self > upper:
			return upper.Between(self)
		i = 0
		b = min(len(self.listRep),
			len(upper.listRep))
		while i < b:
			j = 0
			innerB = min(len(self.listRep[i]),
				len(upper.listRep[i]))
			while j < innerB :
				if (self.listRep[i][j] < 
					upper.listRep[i][j]):
					return self.InnerBetween(upper,i,j)
				j = j + 1
			
			if len(upper.listRep[i]) != len(self.listRep[i]):
				return self.InnerBetween(upper,i,j-1)
			i = i + 1
		
		if len(upper.listRep) > len(self.listRep):
			return self.InnerBetween(upper,i,0)
		assertBad

	def InnerBetween(self, upper, i, j ):
		c = DecQuantity()
		c.listRep = self.listRep[0:i]
		
		if (len(self.listRep) < i):
			k = 0
			toBuild = []
			while ( k < len(upper.listRep[i]) 
				and (upper.listRep[i][k] == 0)):
				toBuild.append( upper.listRep[i][k] )
				k = k + 1
			
			if k < len(upper.listRep[i]):
				toBuild.append(upper.listRep[i][0])
			else:
				toBuild.append(-1)
			c.listRep.append(toBuild)
			return c
		
		c.listRep =  (c.listRep 
			+ [self.listRep[i][0:j]])
		
		if ( self.listRep[i][j] + 1==
			upper.listRep[i][j]):
			c.listRep[i].append(
				self.listRep[i][j])
			if len(self.listRep[i]) < j+2:
				c.listRep[i].append(5)
			else:
				c.listRep[i].append(
					self.listRep[i][j+1] + 1)
		
		elif ( self.listRep[i][j] ==
			upper.listRep[i][j]):
			if( len(upper.listRep[i]) >
				len(self.listRep[i]) ):
				c.listRep[i].append(
					upper.listRep[i][j])
				if (upper.listRep[i][j+1] == 0):
					c.listRep[i].append(
						upper.listRep[i][j+1])
					c.listRep[i].append(-1)
				else:
					c.listRep[i].append(
						upper.listRep[i][j+1]-1)
		else:
			c.listRep[i].append(
				(self.listRep[i][j] 
				+ upper.listRep[i][j])/2)
		return c



	#Create a subtree from the value
	#This transforms an existing value
	def SubIndex(self,numString):
		self.listRep = (self.listRep + 
			DecQuantity().ParseSerialNum(numString).listRep)
	
	def Parent(self):
		parent = self.ACopyOf()
		if len(self.listRep) > 1:
			parent.listRep = self.listRep[:-1]
			return parent
		else:
			return None
		
	
	def lastDecimal(self):
		res = self.ACopyOf()
		res.listRep = [self.listRep[-1]]
		return res
			
	def Decimalize(self,Quant):
		aCopy = self.ACopyOf()
		if type(Quant) == type(0):
			aCopy.listRep.append([Quant])
		elif type(Quant) == type(DecQuant()):
			aCopy.listRep = aCopy.listRep + Quant.listRep
		return aCopy

	def BeginSub(self):
		return self.Decimalize(0)
		
	def ParseSerialNum(self,counterView):
		import Prod
		if type(counterView) == type(""):
			counterView = Prod.TextView(counterView)
		
		res = DecQuantity()
		res.listRep = []
		i = 0
		numString = ''
		toBuild = []
		while( counterView.MoreText() ):
			chr = counterView.AtTextView() 
			#No whitespace allowed in serial numbers!!
			while( (chr == '-' and numString == '')
				or chr in string.digits):
				numString = numString + chr
				counterView.Next()
				if not counterView.MoreText():
					chr = ''
					break
				else:
					chr = counterView.AtTextView() 
			
			if chr == DELIM1:
				toBuild.append(string.atoi(numString))
				numString = ''
				counterView.Next()
			else:
				if numString == '':
					break
				toBuild.append(string.atoi(numString))
				res.listRep.append(toBuild)
				numString = ''
				if chr == DELIM2:
					counterView.Next()
				i = i + 1
				toBuild = []
				if chr != DELIM2:
					break
		
		if len(res.listRep) == 0:
			return None
		
		return res		
	
	def Increment(self):
		self.listRep = [[c.listRep[0][0] + 1]] 
	
	def NextHigher(self):
		aCopy = self.ACopyOf()
		aCopy.Increment()
		return aCopy
		
	def ZeroOut(self):
		self.listRep = [c.listRep[0]] 

	#This only makes sense for Decimal Quantities
	def QuantLevel(self):
		return len(self.listRep)
	
	def SectionWithin(self,levelStart, levelEnd):
		self.listRep[levelStart:levelEnd]

SomeDecQuantity = DecQuantity()
TheDecQuantityType = type(SomeDecQuantity)

