#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

# Test script for serial number class

import os
import dircache
import Mycgi 
import regex
import regsub
import string
import copy
import Token
import Util
import profile
import Prod
import SerialNumber

from string import *
from Util import *

def main():
	
	v1 = Prod.TextView('1;1;3;6;1.1')
	v2 = Prod.TextView('1;1;3;6;1.2')
	v3 = Prod.TextView('11.13.5;13;11.13.5;12.15.4')
	v4 = Prod.TextView('11.14.5;12.15.4;7;12.15.4')
	v5 = Prod.TextView('12;1')
	v6 = Prod.TextView('12;1.0')
	
	v7 = Prod.TextView('12.13.5;12.15.4')
	v8 = Prod.TextView('12.15.4')
	v9 = Prod.TextView('13')
	v10 = Prod.TextView('14')
	
	
	
	v1.Reset()
	
	dq1 = SerialNumber.DecQuantity().ParseSerialNum(v1)
	dq2 = SerialNumber.DecQuantity().ParseSerialNum(v2)
	dq3 = SerialNumber.DecQuantity().ParseSerialNum(v3)
	dq4 = SerialNumber.DecQuantity().ParseSerialNum(v4)
	dq5 = SerialNumber.DecQuantity().ParseSerialNum(v5)
	dq6 = SerialNumber.DecQuantity().ParseSerialNum(v6)
	dq7 = SerialNumber.DecQuantity().ParseSerialNum(v7)
	dq8 = SerialNumber.DecQuantity().ParseSerialNum(v8)
	dq9 = SerialNumber.DecQuantity().ParseSerialNum(v9)
	dq10 = SerialNumber.DecQuantity().ParseSerialNum(v10)
	
	print 'dq1: ',
	print dq1
	print 'dq2: ',
	print dq2
	print 'dq3: ',
	print dq3
	print 'dq4: ',
	print dq4
	print 'dq5: ',
	print dq5
	print 'dq6: ',
	print dq6
	print 'dq7: ',
	print dq7
	print 'dq8: ',
	print dq8
	print 'dq9: ',
	print dq9
	print 'dq10: ',
	print dq10
	
	qar = [dq1,dq2,dq3,dq4,dq5,dq6,dq7,dq8,dq9,dq10]
	
	def orderTest(qar):
		for i in range(len(qar)):
			for j in range(len(qar)):
				if i < j:
					if not (qar[i] < qar[j]):
						print 'test failed',
						print qar[i],
						print 'not <',
						print qar[j],
					if (qar[i] == qar[j]):
						print 'test failed',
						print qar[i],
						print '==',
						print qar[j],
					if (qar[i] > qar[j]):
						print 'test failed',
						print qar[i],
						print '>',
						print qar[j],
				if i == j:
					if not (qar[i] == qar[j]):
						print 'test failed',
						print qar[i],
						print 'not ==',
						print qar[j],
					if (qar[i] != qar[j]):
						print 'test failed',
						print qar[i],
						print '!=',
						print qar[j],
				if i > j:
					if not (qar[i] > qar[j]):
						print 'test failed',
						print qar[i],
						print 'not >',
						print qar[j],
						
		print 'order test finished'
	
	orderTest(qar)
	
	def BetweenTest(qar):
		for i in range(len(qar)):
			for j in range(len(qar)):
				if i < j:
					s = qar[i]
					b = ( (qar[i]).Between(qar[j]) )
					e = qar[j]
					print s, 
					print ' |',
					print b,
					print ' | ',
					print e
					print
					
					if not (s< b):
						print 'test failed',
						print s,
						print 'not <',
						print b
					
					if not ( b < e):
						print 'test failed',
						print b,
						print 'not <',
						print e
						
		print 'between test finished'
	
	BetweenTest(qar)
	
	def TestListOrdering(tL):
		pass
		
	
	tL = SerialNumber.QuantList()
	
	tL.Add(dq2,'hi2',)
	tL.Add(dq1,'hi1',)
	tL.Add(dq3,'hi3')
	tL.Add(dq5,'hi5')
	tL.Add(dq4,'wrong')
	tL.Add(dq6,'hi6')
	tL.Add(dq4,'hi4')
	tL.Add(dq8,'hi8')
	tL.Add(dq7,'hi7')
	tL.Add(dq9,'hi9')
	tL.Add(dq10,'hi10')
	
	
	
	print 'tL.At(dq1): ',
	print tL.At(dq1)
	print
	print 'tL.At(dq2): ',
	print tL.At(dq2)
	print
	print 'tL.At(dq3): ',
	print tL.At(dq3)
	print
	print 'tL.At(dq4): ',
	print tL.At(dq4)
	print
	print 'tL.At(dq5): ',
	print tL.At(dq5)
	print
	print 'tL.At(dq6): ',
	print tL.At(dq6)
	print
	print 'tL.At(dq7): ',
	print tL.At(dq7)
	print
	print 'tL.At(dq8): ',
	print tL.At(dq8)
	print
	print 'tL.At(dq9): ',
	print tL.At(dq9)
	print
	print 'tL.At(dq10): ',
	print tL.At(dq10)
	print
	
	print 'tL.NextInSequence()',
	print tL.NextInSequence()
	print 'tL.NodeAt(dq1).NextInSequence()',
	print tL.NodeAt(dq1).NextInSequence()
	print 'tL.NodeAt(dq1).NextInSequence().NextInSequence()',
	print tL.NodeAt(dq1).NextInSequence().NextInSequence()
	print 'tL.NodeAt(dq2).NextInSequence()',
	print tL.NodeAt(dq2).NextInSequence()
	print 'tL.NodeAt(dq2).NextInSequence().NextInSequence()',
	print tL.NodeAt(dq2).NextInSequence().NextInSequence()
	print 'tL.NodeAt(dq3).NextInSequence() ',
	print tL.NodeAt(dq3).NextInSequence()
	print 'tL.NodeAt(dq4). NextInSequence()',
	print tL.NodeAt(dq4).NextInSequence()
	print 'tL.NodeAt(dq5).NextInSequence() ',
	print tL.NodeAt(dq5).NextInSequence()
	print 'tL.NodeAt(dq6).NextInSequence() ',
	print tL.NodeAt(dq6).NextInSequence()
	print 'tL.NodeAt(dq7).NextInSequence() ',
	print tL.NodeAt(dq7).NextInSequence()
	print 'tL.NodeAt(dq8).NextInSequence() ',
	print tL.NodeAt(dq8).NextInSequence()
	print 'tL.NodeAt(dq9).NextInSequence() ',
	print tL.NodeAt(dq9).NextInSequence()
	print 'tL.NodeAt(dq10).NextInSequence() ',
	print tL.NodeAt(dq10).NextInSequence()
	
	
	print 'tL.firstChild: ', 
	print tL.firstChild 
	print 'tL.lastChild: ', 
	print tL.lastChild 
	
	"""print 'tL.ChildList(dq1,dq10): ', 
	print tL.ChildList(dq1,dq10) 
	print 'tL.ChildList(dq9,dq10): ', 
	print tL.ChildList(dq9,dq10) 
	print 'tL.ChildList(dq1,dq9): ', 
	print tL.ChildList(dq1,dq9) """
	
	print 'tL.AsList()' ,
	print tL.AsList()
	
	print 'tL.ll_Diagnosticf()'
	tL.ll_Diagnosticf()
	print 'tL.ll_Diagnosticb()'
	tL.ll_Diagnosticb()
	
	print 'tL.firstChild ',
	print tL.firstChild
	print 'tL.firstChild.nextSib ',
	print tL.firstChild.nextSib 
	print 'tL.firstChild.nextSib.nextSib ',
	print tL.firstChild.nextSib.nextSib 
	print 'tL.firstChild.nextSib.prevSib ',
	print tL.firstChild.nextSib.prevSib 
	
	
	print 'tL.lastChild ',
	print tL.lastChild
	print 'tL.lastChild.prevSib ',
	print tL.lastChild.prevSib 
	
	
	
	print 'tL: '
	print tL
	
if __name__ == '__main__':
    main()
