#Generic Caching Container For dictionaries

#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

import os
import stat
import dircache
import regex
import regsub
import string
import copy
import profile
import sys
import pickle
import pdb




#import traceback
# We have import everything we are going to 
# reconstitute !!! Wacky invisible dependency!
#from Prod import *
#import Prod
import MySerialNumber
import MyToken
import Production
import SerialNumList
import ProdItterate
import MyAdmin

class CacheFile:
	def __init__(self,filename, allowNull = 1):
		
		self.isDirty = 0
		self.filename = filename
		try:
			try:
				fpt = open(self.filename,'r')
				u = pickle.Unpickler(fpt)
				self.cachedDict = u.load()
			finally:
				if fpt is not None:
					fpt .close()
					if not allowNull:
						raise FileError, 'File Cache File Not Found'
		except:
			self.cachedDict = {}
			if not allowNull:
				raise FileError, 'File Cache File Not Found'

	def Flush(self):
		if self.isDirty:
			fpt = open(self.filename,'w')
			p = pickle.Pickler(fpt)
			p.dump(self.cachedDict)
			fpt.close()
			self.isDirty = 0

	def modTime(self):
		st = os.stat(self.filename)
		return st[stat.ST_MTIME]

#A persistance dictionary object
#The dictionary object is a 
class GenericCache:
	def __init__(
		self,
		persistanceName,
		cachedFile,
		baseType = None):
		#pdb.Pdb().set_trace()
		if baseType is None:
			baseType = {}
		self.itsCache = cachedFile
		self.persistanceName = persistanceName
		if self.itsCache.cachedDict.has_key(persistanceName):
			self.cachedDict = self.itsCache.cachedDict[persistanceName]
		else:
			self.itsCache.isDirty = 1
			self.cachedDict = baseType
			self.itsCache.cachedDict[persistanceName] = self.cachedDict


	def __del__(self):
		if self.cachedDict is not None:
			self.itsCache.cachedDict[self.persistanceName] = self.cachedDict

	def flush(self):
		self.itsCache.cachedDict[self.persistanceName] = self.cachedDict
		self.cachedDict = None
		

	#From UserDict		
	def __len__(self): return len(self.cachedDict)
	def __getitem__(self, key): return self.cachedDict[key]
	def __setitem__(self, key, item):
		#pdb.set_trace()
		self.itsCache.isDirty = 1
		self.cachedDict[key] = item
	def __delitem__(self, key):
		self.itsCache.isDirty = 1
		del self.cachedDict[key]
	def keys(self): return self.cachedDict.keys()
	def items(self): return self.cachedDict.items()
	def values(self): return self.cachedDict.values()
	def has_key(self, key): return self.cachedDict.has_key(key)
	def Add(self, quant, object):
		self.itsCache.isDirty = 1
		self.cachedDict[quant] = object
	def At(self,quant):
		self.cachedDict[quant] 


def main():
	x = CacheFile('testFile.bin')
	g = CacheFile('testFile2.bin')
	y = GenericCache('first',x)
	w = GenericCache('happy',g)
	y['a'] = ('1' + '3')
	y['c'] = ('22' + y['a'])
	w['n'] = ('In second - shouldnt appear')
	z = GenericCache('second',x)
	z[0] = 'third value'
	z[1] = 'fourth value'
	#m = GenericCache('ThirdQuantList',x,SerialNumList.QuantList())
	#m['0'] = 4
	del y
	del z
	#del m
	x.Flush()
	g.Flush()
	#del x

	p = CacheFile('testFile.bin')
	q = GenericCache('first',p)
	print q['a'] 
	print q['c']
	print q.keys()
	
	z = GenericCache('second',p)
	print z.cachedDict
	print z[0]
	#n = GenericCache('ThirdQuantList',p,SerialNumList.QuantList())
	#print n['0'] 
	del q
	del z
	del p
	#p.Flush()


	
if __name__ == '__main__':
	main()


