
#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

#Our Token are our basic objects created by "productions."
#

import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
#import re
import string
import string
from string import *
import types
import copy

import MyAdmin
import MyUtil
import profile
import Prod
import MySerialNumber
import MyControl
import Production
import ProdItterate

global TheToken


def RecursiveCopy(stringListOrToken):
	if type(stringListOrToken) == types.InstanceType:
		return stringListOrToken.ACopyOf()
	elif type(stringListOrToken) == type(""):
		return stringListOrToken
	elif type(stringListOrToken) == type([]):
		result = []
		for x in stringListOrToken:
			result.append(RecursiveCopy(x))
		return result
	else:
		raise TypeError, "Can only copy list,string or tokens"


class Token:
	#creating a token with just a string creates a terminal
	globalValues = {}
	def __init__(self, inputStringOrList ="", 
			theTokenType = 'terminal',
			serialNum = None):
		if inputStringOrList is None:
			self.listORtoken = ""
			return
		self.serialNum = None
		self.localDefines = {}
		self.localDefSerialNums = {}
		self.globalItem = None
		self.args = []
		if serialNum is not None:
			self.serialNum = serialNum.ACopyOf()
		
		#terminals must always be strings
		self.prodWithin = None
		if ( (type(inputStringOrList) == 
			type(self)) and
			(inputStringOrList.__class__ == 
			Production.Production().__class__)):
			self.tokenType = 'prod'
			self.prodWithin = inputStringOrList
			self.stringOrList = ""
		elif (type(inputStringOrList) == type([])
			and theTokenType == 'terminal'):
			self.tokenType = 'list'
			self.stringOrList = inputStringOrList
		else:
			self.stringOrList = inputStringOrList
			self.tokenType = theTokenType
		self.isTracer = 0
		self.parent = None
		self.itemName = ''
		self.killLevel = 0 
	
	def __nonzero__(self):
		return(self.stringOrList is not None
			   and (self.stringOrList != ''))
	
	def __add__(self,other):
		result = self.__str__()
		return result + other

	#self is the right addend
	def __radd__(self,other):
		selfString = self.__str__()
			
		if type(other) == type(Token):
			otherString = other.__str__()
		elif type(other) == type(""):
			otherString = other
		else:
			raise TypeError, "Not A String Token, can't add text"
		
		return otherString + selfString
			
	def __len__(self):
		if(type(self.stringOrList) == type([])):
			return len(self.stringOrList)
		if(type(self.stringOrList) == type("")):
			return len(self.stringOrList)
		if(type(self.stringOrList) == types.InstanceType):
			return len(self.stringOrList)
		return 0

	def AsSubTag(self):
		itemString = self.__str__(0,1)
		#Allow us to have a tag substitute
		if itemString[:len('*tagas')] == '*tagas':
			ProdStrings = ProdItterate.Split(itemString,'*',0)
			#str = ProdItterate.ProdItterator(
			#	).Tagas(ProdStrings,1)
			#return str
			theTag = ProdStrings[1]
			remainder  = ''
			for x in ProdStrings[2:]:
				x = ProdItterate.Strip(x)
				remainder  = remainder  + '*(' + x + ')' 
			#remainder = reduce((lambda a,b: a+'*'+ b),ProdStrings[2:],'')
			return ('<' + theTag + ' '
					+ bbsAttrSubstituteTag +'="' +
					remainder + '">')
			
		return ('<' + bbsSubstituteTag + ' '+\
			   ProdBaseTokenName + '="' +
				self.__str__(0,1) + '">')

	def AsStandAlone(self):
		parentList = []
		counter = self
		while counter.parent is not None:
			parentList.append(counter.parent)
			counter = counter.parent
		parentList.reverse()
		totalDefinesDictionary = {}
		totalSerialNumDictionary = {}
		for x in parentList:
			totalValueDictionary(x.localDefines)
			totalSerialNumDictionary(x.localDefSerialNums)

		result = self.ACopyOf()
		result.localDefines = totalDefinesDictionary
		result.localDefSerialNums = totalSerialNumDictionary 
		result.tokenType = 'appender'
		return result

	#this opperates ON a given token, 
	#so copy first if you needoriginal
	def DoSubstitution(self,contextToken, contextItter):
		if type(self.stringOrList) == type(''):
			if (len(self.stringOrList)>0 
				and (self.stringOrList[0] in MyUtil.token_commands)):
				newTok = contextItter.EvaluateToken(
						self.stringOrList, 1)
				test = newTok.ToBaseString()
				if test !='':
					self.stringOrList = string.strip(test)
					self.tokenType = newTok.tokenType
			return 1
		elif type(self.stringOrList) == type([]):
			for x in self.stringOrList:
				x.DoSubstitution(contextToken, contextItter)
			
			if len(self.stringOrList) > 1:
				realString = self.stringOrList[1]
				while type(realString) == types.InstanceType:
					realString = realString.stringOrList

				if realString == '++' or realString == '--':
					if (realString  == '++'): step = 1
					else: step = -1
	
					realKey = self.stringOrList[0]
					while type(realKey) == types.InstanceType:
						realKey = realKey.stringOrList
					curVal = contextToken.GetSetNumber(realKey)
					
					newVal = curVal + step
					self.stringOrList[1] = Token('%d' % newVal,'nt')
			return 1
			
		elif type(self.stringOrList) == types.InstanceType:
			self.stringOrList.DoSubstitution(
					contextToken, 
					contextItter)
			return 1
		assertBad
	
					
	def ACopyOf(self):
		#constructor should add new serial num	
		result = Token()
		result.stringOrList =  RecursiveCopy(self.stringOrList)
		result.tokenType = self.tokenType 
		result.localDefines = \
			copy.copy(self.localDefines)
		result.localDefSerialNums = \
			copy.copy(self.localDefSerialNums)
		result.itemName = self.itemName 

		result.parent = None #new in hierarchy
		result.serialNum = self.serialNum
		return result

	#this implicity sets lots of other values
	def SetAsParent(self,parent):
		if type(parent) != types.InstanceType:
			raise TypeError, 'parent must be token'
		self.parent = parent

	def AddSpacesWithCap(self,ToAddSpaces):
		for i in range(1,len(ToAddSpaces)-1):
			if (ToAddSpaces[i-1] in string.lowercase and
				ToAddSpaces[i] in string.uppercase):
				ToAddSpaces = (ToAddSpaces[:i] 
					+ ' ' + ToAddSpaces[(i):])
		
		return ToAddSpaces
	
	#array of 
	def GetSetNumber(self,theString):
		theString = string.strip(theString )
		theString = string.upper(theString )
		
		if self.localDefines.has_key(theString):
			res = self.localDefines[theString]
			if type(res) == type(0):
				return res
			elif MyUtil.IsStringNumber(res):
				b = string.atoi(res)
				return b
			else: 
				return 0
		
		#elif theString in self.localDefines.values():
		#	return 0
		else:
			if(self.parent is not None):
				res = self.parent.GetSetNumber(theString)
				if(type(res) == type(0)):
					return res
				else:
					return 0
			#also test production
			else:
				if Prod.ProdList.theProdList.has_key(theString):
					return 0
				else:
					return -1

	
	#This lets us specify virtually any local item, 
	def GetSetString(self,theString,listIndex = None,getProd = 1):
		theString = string.strip(theString )
		theString = string.upper(theString )
		result = ""
		
		if(theString == 'STRING'):
			if type(self.stringOrList) == type(""):
				result = self.stringOrList
				result = self.AddSpacesWithCap(result)
			else:
				result = ""
		elif(theString == 'ISADMINOPTION'):
			#pdb.Pdb().set_trace()
			if (MyAdmin.UserList().currentUser is not None
				and MyAdmin.UserList().currentUser != ""):
				result = '1'
			else:
				result = ""
			
		elif self.localDefines.has_key(theString):
			res = self.localDefines[theString]
			if(type(res) == type("")):
				result = res
			else:
				if(type(res) == type(0)):
					result = '%d' % res
				elif(type(res) == type([]) and
					type(listIndex) == type(0)):
					if(len(res) >listIndex ):
						result = res[listIndex]
					else:
						return None
				elif type(res) == types.InstanceType:
						return res.ToBaseString()
				
				elif type(res) == TheDecQuantityType:
						return res.__str__()
				else:
					raise TypeError, 'A non-string,non-number'\
					' got into the local defines'
		else:
			if(self.parent is not None):
				result = self.parent.GetSetString(theString,
										listIndex)
			else:
				res = ""
				if(type(listIndex) == type("")):
					res = self.IndexedResult(theString,
									listIndex)
				if res == "":
					theCgiValue = MyControl.pageLoader().CgiValue(theString)
					if(theCgiValue!=''):
						theCgiValue = MyUtil.AddControlChars(theCgiValue)
						res = theCgiValue
					
				if res == "" and getProd:
					if (type(listIndex) ==
						MySerialNumber.TheDecQuantityType):
						keyTok = Token(theString,'nt',listIndex)
						theProd = Prod.ProdList(
							).ProdFromKey(keyTok)
					else:
						theProd = Prod.ProdList(
							).ProdFromKey(theString)
					
					if theProd is not None:
						res = theProd.FirstStringToken()
						if res.tokenType == 'terminal':
							res = res.ToFormattedString()
						else:
							res = res.ToBaseString()

				MyUtil.Assert(type(res) == type(""))
				result = res
				
		#now validate result to return a string
		if (result is None) or (type(result) != type("")):
			return ""
		else:
			return result

	#This lets us specify virtually any local item, 
	def GetSetSerialNum(self,theString):
		theString = string.strip(theString )
		theString = string.upper(theString )
		
		res = None
		
		if self.localDefSerialNums.has_key(theString):
			res = self.localDefSerialNums[theString]
		
		if(res is None or res.IsNull()):
			if self.localDefines.has_key(theString):
				toParse = self.localDefines[theString]
				if type(toParse) == type(0):
					toParse = '%d' % toParse
				res  = MySerialNumber.SomeDecQuantity.ParseSerialNum(
					toParse)
		
		if(res is None or res.IsNull()):
			if(self.parent is not None):
				res = self.parent.GetSetSerialNum(theString)
		
		#now validate result to return a string
		if res is not None:
			return res.ACopyOf()
		else:
			MyUtil.errorLog.append(
				'Null serialNumber for ' 
				+ theString)
			return None
		

	#still have to make this local to a production somehow
	#
	#ListIndex is a list of either numbers or strings.
	def IndexedResult(self,key,listIndex):
		P = Prod.ProdList().theProdList
		
		if(not P.has_key(key)):
			return ''
		TokenProducedByX = P[key]
		if(TokenProducedByX is None):
			return ''
		
		ListODaToken = TokenProducedByX.stringOrList
		
		if( type(listIndex) == type('') ):
			for x in ListODaToken:
				if(type(x) == type([])
					and (x[0]==listIndex)):
					if(len(x) > 1): 
						return x[1]
					else: return ''
			return ''
						
		if(type(listIndex) == type(0)):
			return ListODaToken [listIndex]
		
		return ''

	def SetSerialNumber(self,
		aKey,
		theSerialNum):
		if type(aKey) != type(""):
			if(type(aKey) == types.InstanceType):
				theKey = aKey.ToBaseString()
			else:
				assertBad
		else:
			theKey = aKey
		MyUtil.Assert(theKey is not None)
		MyUtil.Assert(theSerialNum is not None)
		theKey = string.upper(theKey)
		theKey = string.strip(theKey)
		self.localDefSerialNums[theKey] = theSerialNum 
	
	def SetStringValues(self,
		theKey, 
		aValue, 
		theSerialNum = None):
		#always set theValue unless it's defined as a non-number
		
		if(type(aValue) == types.InstanceType):
			if theSerialNum is None:
				theSerialNum = aValue.serialNum
			theValue = aValue.ToBaseString()
		else:
			theValue = aValue

		theKey = string.strip(theKey)
		theKey = string.upper(theKey)
		
		if(theValue is None):
			return 0
		
		MyUtil.SyntaxRequire(
			type(theValue) != type([]) )
		
		#set higher value at child from parent
		if theValue == '++' or (theValue == '--'):
			if (theValue == '++'): step = 1
			else: step = -1

			curVal = self.GetSetNumber(theKey)
			newVal = curVal + step
			self.localDefines[theKey] = newVal
			if theValue == '++':
				if Token.globalValues.has_key(theKey):
					if newVal  > Token.globalValues[theKey]:
						Token.globalValues[theKey] \
							= newVal 
			return 1

		else:
			if theSerialNum is not None:
				self.localDefSerialNums[theKey] = theSerialNum 

			if MyUtil.IsStringNumber(theValue):
				theValue = string.atoi(theValue)
				self.localDefines[theKey] = theValue
				if Token.globalValues.has_key(theKey):
					if theValue > Token.globalValues[theKey]:
						Token.globalValues[theKey] \
							= theValue
				else:
					Token.globalValues[theKey] \
						= theValue
			else: 
				self.localDefines[theKey] = theValue
	
	def __str__(self, forDisplay = 1, hideQuotes = 0):
		if type(self.stringOrList) == type([]):
			if len(self.stringOrList) == 0:
				body = ""
			else:
				listOrString = map(Token.__str__, 
								self.stringOrList)
				body = reduce(lambda x,y: x +','+ y,
						self.stringOrList)
			result = '[' + body + ']'
		else:
			if self.tokenType == 'terminal':
				if forDisplay:
					result = self.ToFormattedString()
				else:
					result = self.ToSaveableString()
				if not hideQuotes:
					result =  "'" + result + "'"
			else:
				result = self.stringOrList
		return result


	#remove the controlChar '~' from string if it's before
	#A 
	def ToFormattedString(self):
		import re		
		stringOne = "~(.)"
		stringTwo = '\\1'
		str = re.sub(
					stringOne, 
					stringTwo,
					self.stringOrList )
				
		return str

	#Add control codes to string
	def ToSaveableString(self):
		import re
		stringOne = "([^~])(')"
		stringTwo = "\\1~\\2"
		str = re.sub(
					stringOne, 
					stringTwo,
					self.stringOrList )
				
		return str
		
	def ToBaseString(self):
		str = self.stringOrList
		while  type(str) == types.InstanceType:
			str = str.stringOrList
		if type(str) == type(""):
			return str
		else:
			raise TypeError, 'Not A Base Token'

	#def IsList(self):
	#	if type(self.stringOrList) == type([]):
	#		return 1
	#	else:
	#		return 0
	
	def IsTransform(self):
		test = self.stringOrList
		while( type(test) ==types.InstanceType ):
			test = test.stringOrList
			
		if ( type(test) == type([]) 
			and (len(test) >1) ):
			return 1
		else:
			return 0
	
	def Key(self):
		test = self.stringOrList
		while( type(test) ==types.InstanceType ):
			test = test.stringOrList
		str = test[0].ToBaseString()
		str = string.upper(str)
		str = string.strip(str)
		return str

		

	#assume an array representing a transformation/define
	def Map(self):
		test = self.stringOrList
		while( type(test) ==types.InstanceType ):
			test = test.stringOrList
		return test[1].ToBaseString()
	
	def SetMap(self,text):
		test = self
		while( type(test.stringOrList) ==types.InstanceType ):
			test = test.stringOrList
		test.stringOrList[1] = Token(text,'nt')
	
	def IsNull(self):
		if (type(self.self.stringOrList) == type('') and
			(self.self.stringOrList == '')):
			return 1
		else:
			return 0
	def SetGlobalValue(self,key,value):
		key = string.upper(key)
		key = string.strip(key)
		Token.globalValues[key] = value


	def GetGlobalValue(self,key):
		key = string.upper(key)
		key = string.strip(key)
		if Token.globalValues.has_key(key):
			return Token.globalValues[key]
		else:
			return 0

TheToken = Token()

