
#Crucial Questions Better BBS 
#Copyright 2000 Hans Joseph Solbrig
#
#See License Agreement in distribution

import os
import dircache
import Mycgi #cgi tweeked for non-unix systems
import regex
import regsub
import string
import copy
import profile
import pdb
#import MyToken


# Reserve the characters ~ \ / : , ' "| []
global token_commands 
token_commands = '*$&+!@%#|'

numbers = '0123456789'

baseFileName = 'base.bbs'
baseFilePath = '.'
postFileName = 'posts.bbs'
DynaTextName = 'user_dynamic_text'
basePath = '.'
myArgs = ''

#Various Extensions
CompileHtmlExten = 'cpd'
BackupHtmlExten = 'bth'
CompileProdExten = 'cpe'
BasicProdExten = 'prd'

global errorLog
errorLog = []

global generatedProds
generatedProds = []

global commandTokenText 
commandTokenText = ''

global DebugTrace
DebugTrace = 0

global userDynamicProductions
userDynamicProductions = ''

global theForm
theForm = {}

global MaxParagraphLength
MaxParagraphLength = 600

global BBS_SYNTAX_ERROR 
BBS_SYNTAX_ERROR = "BBS SYNTAX ERROR"

global splitChar
splitChar = '_'

AllProdTags = []
#---------HTML BLOCK CONSTANTS
bbsProdNameTag = 'bbsembedprodnametag'
#Inserts an 'nt' along with the terminal text in the base production,
bbsSubstituteTag = 'bbsembedsubstitutetag'
AllProdTags.append(bbsSubstituteTag )
ProdBaseTokenName = 'prodbasetokenname'

bbsAttrSubstituteTag  = 'bbsattrssubstitutetag'
AllProdTags.append(bbsAttrSubstituteTag )

#Inserts an 'nt' along with the terminal text in base production,
#and treates the tagged text as defining a sub production
#Can be multiply nested
bbsEmbedProdTag = 'bbsembedprodtag'
AllProdTags.append(bbsEmbedProdTag )

#Ways to embed
#- dummy means ignore whatever TERMINAL text is within
#- expand means place the initial definition of the prod in the text. 
bbsEmbedProdMethodName = 'bbsembedprodmethod' #dummy or expand...

#Inserts an series 'nt' within terminal text, and treates
#the tagged text as defining the subseries - either derives
#productions or defines productions
bbsEmbedProdSubSequenceTag = 'bbsembedprodsubsequencetag'
AllProdTags.append(bbsEmbedProdSubSequenceTag)

#Inserts an 'nt' with terminal text, and treates
#tagged text as defining the production
bbsEmbedProdSequenceTag = 'bbsembedprodsequencetag'
AllProdTags.append(bbsEmbedProdSequenceTag)
ProdBaseSerialNumName = 'prodbaseserialnumname'

bbsSubstituteAndExpandTag = 'bbssubstituteandexpandtag'
AllProdTags.append(bbsSubstituteAndExpandTag)

def AdjustPath(fileName):
	#if os.name != 'nt':
	#	return "/web/crucialquestions/cgi-bin/"+ fileName
	return fileName


def SyntaxRequire( value, y = None, z = None, errorType =None):
	if errorType is None:
		errorType = BBS_SYNTAX_ERROR
	
	if not value:
		if y is not None:
			if z is not None:
				raise errorType, y, z
			raise errorType, y
		raise errorType
	return value


class empty:
	def __init__(self):
		pass

theUserType = type(empty())

#The following classes and objects allow debug 
#info to be written to a file. 

class outFile:
	errorBuffer = 'Begin Error Buffer\n'
	outFP = None	
	isDebug = 0
	isDebugTracing = 0
	def __init__(self):
		if outFile is None:
			outFile.outFP = open("out.out",'w')
	def __del__(self):
		#self.outFP.write(outFile.errorBuffer)
		if (outFile is not None 
			and outFile.outFP is not None):
			outFile.outFP.close()
			outFile.outFP = None

AssertFailed = 'Assert Failure'

dummy = outFile()

#don't set trace if going throug apache!!
def Assert(s):
	if not s:
		if outFile.isDebugTracing:
			if outFile.isDebug == 0:
				pdb.set_trace()
				outFile.isDebug = 1
			else:
				print '--assert failure again--'
		else: 
			raise AssertFailed, 'see traceback'

def DoNothing(message):
	pass

def TraceTokenIn(actionToken):
	if actionToken is not None:
		DebugOut('\nOur input token for evaluate: ')
		DebugOut(actionToken)
		DebugOut(actionToken.serialNum)
		if self.parentToken is not None:
			DebugOut('\nIts parent: ')
			DebugOut(self.parentToken)
			DebugOut(self.parentToken.serialNum)
	else:
		DebugOut('\nOur input token for evaluate: ITS None')
		
	DebugOut('\n')
	

def writeBuffer(string):
	if outFile.outFP is None:
		outFile.outFP = open("out.out",'w')
	outFile.outFP.write(string)
	outFile.outFP.flush()
	if outFile.isDebug == 1:
		print string

	
def DebugOut(message):
	import Prod
	import MySerialNumber

	if(type(message) == type(None)):
		writeBuffer('None\n' )
	elif(type(message) == type(0)):
		writeBuffer('A num: ')
		writeBuffer('%d' % message)
	elif(type(message) == type("")):
		writeBuffer(message)
	
	elif hasattr(message,'__str__'):
		writeBuffer(message.__str__())
	
	elif type(message) == theUserType  :
		writeBuffer(message.ToBaseString())
		writeBuffer('A Tok: ')
		writeBuffer(message.__str__())
		writeBuffer('\n')
		if message.serialNum is not None:
			writeBuffer('The serial Num: ')
			writeBuffer(serialNum)
		else:
			writeBuffer('NULL serial number: ')
		#writeBuffer(message.path)
		par = message.parent
		startNum = message.serialNum
		
		count = 0
		while par is not None and (count < 20):
			if(startNum == par.serialNum):
				writeBuffer('self-referencing token!!')
				break 
			writeBuffer(" p: ")
			writeBuffer(par.AsString())
			writeBuffer(par.serialNum)
			writeBuffer(par.path)
			writeBuffer(': ')
			count = count + 1
			par = par.parent
		writeBuffer('\n')

	elif( type(message) == type(Prod.TextView('')) ):
		writeBuffer('TextView: ')
		writeBuffer(message.textBody[message.textCount:])
		writeBuffer('textCount: ')
		writeBuffer(message.textCount)
		writeBuffer('\n')
	
	elif(type(message) == type([])):
		writeBuffer('A list: ')
		if(len(message) == 0):
			writeBuffer('that is an empty list-itity list')
			writeBuffer('\n')
		else: 
			writeBuffer('\n')
			writeBuffer('Begin list')
			writeBuffer('[ ')
			for x in message:
				DebugOut(x)
				writeBuffer(', ')
			writeBuffer('] End list')
			writeBuffer('\n')
	elif(type(message) == type({})):
		writeBuffer('\n')
		writeBuffer('A dictionary: ')
		if(len(message.keys()) == 0):
			writeBuffer('this is an empty diction')
			writeBuffer('\n')
		else: 
			DebugOut('\n')
			DebugOut('{')
			for x in message.keys():
				DebugOut('[')
				DebugOut(x)
				DebugOut(':')
				DebugOut(message[x])
				DebugOut('], ')
			DebugOut('}')
			DebugOut('\n')
			DebugOut('End dictionary')
	else:
		writeBuffer('An other type: ')
		try:
			writeBuffer(message.__str__())
		except AttributeError:
			writeBuffer('With not print function: ')
		
		writeBuffer('\n')


			

##Parsing functions that perhaps should 
##eventually be their file
##Ment to replace regex.split

#Splits tokens the match NO character in c and 
#those that match any ordering of characters in c
def Split(toSplit, c, includeDelim):
    Assert('(' not in c)
    if len(c) == 1:
    	return SplitWOne(c, toSplit,includeDelim)
    if len(c) > 1:
        return SplitWMany(c, toSplit,includeDelim)

def SplitWMany(c, toSplit, includeDelim):
	result = []
	baseI = 0
	i = 0
	l = len(toSplit)
	while i < l:
		s = toSplit[i]
		if s in c:
			matchStr = ""
			while(1):
				if i !=0 and (matchStr==""): 
					result.append(toSplit[baseI:i])
				matchStr = matchStr + s
				i = i + 1
				s = toSplit[i]
				if s not in c:
					if includeDelim:
						result.append(matchStr)
					baseI = i 
					break
				
		elif s == '(':
			i = SkipParens(i+1,toSplit)
		else:
			i = i + 1

	if baseI != l:
		result.append(toSplit[baseI:l])
	return result
    

def SplitWOne(c, toSplit,includeDelim):
	result = []
	baseI = 0
	i = 0
	l = len(toSplit)
	while i < l:
		s = toSplit[i]
		if s == c :
			if i !=0: 
				result.append(toSplit[baseI:i])
			if includeDelim:
				result.append([c])
			baseI = i + 1
		if s == '(':
			i = SkipParens(i+1,toSplit)
		else:
			i = i + 1

	if baseI != l:
		result.append(toSplit[baseI:l])
	return result

def SkipParens(i,toSplit):
	parenCount = 1
	l = len(toSplit)
	while(i < l and (parenCount > 0)):
		x = toSplit[i]
		if x == '(':
			parenCount = parenCount + 1
		if x == ')':
			parenCount = parenCount - 1
		i = i+1
	return i
	
##Misc Utility Functions

def IsStringNumber(str):
	theStr = string.strip(str)
	try: 
		y = string.atoi(theStr)
		return 1
	except: 
		DebugOut('not a number')
		ValueError
		return 0
	
def RemoveCustomControl(theString):
	return regsub.gsub('~\(.\)','\\1',theString)
	
def AddControlChars(theString):
	res = ''
	for x in theString:
		if x == "'":
			res = res + "~'"
		else:
			res = res + x
	return res
		
	
#Reduces a name to digits + char 'A'				
global mangledDigitDilim
mangledDigitDilim = 'A'

def MangleString(theString, fakeMangle = 1):
	if fakeMangle:
		mangled = ""
		for i in theString:
			if i =='\\': 
				pass
			elif i in string.whitespace:
				pass
				#mangled = mangled + '~' + ord(i)
			else:
				mangled = mangled + i
		return mangled #mangling disabled
	#mangling disabled
	
	else:	
		mangledName = ""
		for x in theString: mangledName = mangledName + (
				('%d' % ord(x)) + mangledDigitDilim )
		return mangledName

#String should be 234A34A56A
def UnMangleString(mangledName, fakeMangle = 1):
	if fakeMangle:
		Unmangled = ""
		for i in mangledName:
			if i !='\\':
				Unmangled = Unmangled + i
		return Unmangled #mangling disabled
	else:
		accumNumStr = ""
		unMangledStr = ""
		for y in mangledName:
			if y in string.whitespace:
				continue
			elif y != mangledDigitDilim:
				accumNumStr = accumNumStr + y
			else:
				try:
					unMangledStr = unMangledStr + chr(
							string.atoi(accumNumStr))
					accumNumStr = ""
				except:
					errorLog.append(
						'corrupt mangled name ' 
						+ mangledName)
		return unMangledStr 

	



def RecurSumStringTokList(strTokList):
	if strTokList is None:
		return ""
	elif type(strTokList) == type(""):
		return strTokList
	elif type(strTokList) == type([]):
		
		combinedList = ""
		for x in strTokList:
			combinedList = (
				combinedList 
					+ RecurSumStringTokList(x))
		return combinedList 
	elif type(strTokList) == theUserType :
		return RecurSumStringTokList(
			strTokList.stringOrList)
	else:
		DebugOut('error strTokList')
		DebugOut(strTokList)
		raise TypeError, 'need list,string or Token here'

#CacheClass
import GenericCache
global MainObjectCache 
MainObjectCache = GenericCache.CacheFile('ProdListCache.bin')
AdminCache = GenericCache.CacheFile('AdminCache.bin')


	

			
